Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
+++ kernel/tgb.cc	(revision db83bf13b62d944de021f52de5ae04b7ffd0390e)
@@ -2402,44 +2337,44 @@
 #ifndef NORO_SPARSE_ROWS_PRE
       DenseRow *ref_row = ref->row;
-      if (ref_row == NULL)
-	continue;
+      if(ref_row == NULL)
+        continue;
       number *ref_begin = ref_row->array;
       number *ref_end = ref_row->array + (ref_row->end - ref_row->begin);
       number *my_pos = row + ref_row->begin;
       //TODO npisOne distinction
-      if (!(npIsOne (coef)))
-      {
-	while (ref_begin != ref_end)
-	{
-
-	  *my_pos = npAddM (*my_pos, npMult (coef, *ref_begin));
-	  ++ref_begin;
-	  ++my_pos;
-	}
+      if(!(npIsOne (coef)))
+      {
+        while(ref_begin != ref_end)
+        {
+
+          *my_pos = npAddM (*my_pos, npMult (coef, *ref_begin));
+          ++ref_begin;
+          ++my_pos;
+        }
       }
       else
       {
-	while (ref_begin != ref_end)
-	{
-
-	  *my_pos = npAddM (*my_pos, *ref_begin);
-	  ++ref_begin;
-	  ++my_pos;
-	}
+        while(ref_begin != ref_end)
+        {
+
+          *my_pos = npAddM (*my_pos, *ref_begin);
+          ++ref_begin;
+          ++my_pos;
+        }
       }
 
 #else
       SparseRow *ref_row = ref->row;
-      if (ref_row == NULL)
-	continue;
+      if(ref_row == NULL)
+        continue;
       int n = ref_row->len;
       int j;
       int *idx_array = ref_row->idx_array;
       number *coef_array = ref_row->coef_array;
-      for (j = 0; j < n; j++)
-      {
-	int idx = idx_array[j];
-	number ref_coef = coef_array[j];
-	row[idx] = npAddM (row[idx], npMult (coef, ref_coef));
+      for(j = 0; j < n; j++)
+      {
+        int idx = idx_array[j];
+        number ref_coef = coef_array[j];
+        row[idx] = npAddM (row[idx], npMult (coef, ref_coef));
       }
 #endif
@@ -2459,13 +2394,13 @@
   //wrp(t);
   res_holder.changed = TRUE;
-  if (force_unique)
+  if(force_unique)
   {
     DataNoroCacheNode *ref = cache->getCacheReference (t);
-    if (ref != NULL)
+    if(ref != NULL)
     {
       res_holder.len = ref->value_len;
-      if (res_holder.len == NoroCache::backLinkCode)
-      {
-	res_holder.len = 1;
+      if(res_holder.len == NoroCache::backLinkCode)
+      {
+        res_holder.len = 1;
       }
       res_holder.coef = p_GetCoeff (t, c->r);
@@ -2481,18 +2416,18 @@
   {
     BOOLEAN succ;
-    poly cache_lookup = cache->lookup (t, succ, res_holder.len);	//don't own this yet
-    if (succ)
-    {
-      if (cache_lookup == t)
-      {
-	//know they are equal
-	//res_holder.len=1;
-
-	res_holder.changed = FALSE;
-	res_holder.p = t;
-	res_holder.coef = npInit (1);
-
-	res_holder.onlyBorrowed = FALSE;
-	return res_holder;
+    poly cache_lookup = cache->lookup (t, succ, res_holder.len);        //don't own this yet
+    if(succ)
+    {
+      if(cache_lookup == t)
+      {
+        //know they are equal
+        //res_holder.len=1;
+
+        res_holder.changed = FALSE;
+        res_holder.p = t;
+        res_holder.coef = npInit (1);
+
+        res_holder.onlyBorrowed = FALSE;
+        return res_holder;
       }
 
@@ -2510,5 +2445,5 @@
   unsigned long sev = p_GetShortExpVector (t, currRing);
   int i = kFindDivisibleByInS_easy (c->strat, t, sev);
-  if (i >= 0)
+  if(i >= 0)
   {
     number coef_bak = p_GetCoeff (t, c->r);
@@ -2549,5 +2484,5 @@
     p_SetCoeff (t, one, c->r);
     res_holder.len = 1;
-    if (!(force_unique))
+    if(!(force_unique))
     {
       res_holder.ref = cache->insert (t, t, res_holder.len);
@@ -2579,10 +2514,9 @@
 #ifndef NORO_NON_POLY
 //len input and out: Idea: reverse addition
-poly
-noro_red_non_unique (poly p, int &len, NoroCache * cache, slimgb_alg * c)
+poly noro_red_non_unique (poly p, int &len, NoroCache * cache, slimgb_alg * c)
 {
   assume (len == pLength (p));
   poly orig_p = p;
-  if (p == NULL)
+  if(p == NULL)
   {
     len = 0;
@@ -2595,5 +2529,5 @@
   int unchanged_size = 0;
 
-  while (p)
+  while(p)
   {
     poly t = p;
@@ -2604,18 +2538,18 @@
 #endif
     MonRedRes red = noro_red_mon (t, FALSE, cache, c);
-    if ((!(red.changed)) && (!(red.onlyBorrowed)))
+    if((!(red.changed)) && (!(red.onlyBorrowed)))
     {
       unchanged_size++;
       assume (npIsOne (red.coef));
       assume (p_GetCoeff (red.p, currRing) == coef_debug);
-      if (unchanged_head)
-      {
-	pNext (unchanged_tail) = red.p;
-	pIter (unchanged_tail);
+      if(unchanged_head)
+      {
+        pNext (unchanged_tail) = red.p;
+        pIter (unchanged_tail);
       }
       else
       {
-	unchanged_tail = red.p;
-	unchanged_head = red.p;
+        unchanged_tail = red.p;
+        unchanged_head = red.p;
       }
     }
@@ -2623,19 +2557,19 @@
     {
       assume (red.len == pLength (red.p));
-      if (red.onlyBorrowed)
-      {
-	if (npIsOne (red.coef))
-	{
-	  t = p_Copy (red.p, currRing);
-	}
-	else
-	  t = pp_Mult_nn (red.p, red.coef, currRing);
+      if(red.onlyBorrowed)
+      {
+        if(npIsOne (red.coef))
+        {
+          t = p_Copy (red.p, currRing);
+        }
+        else
+          t = pp_Mult_nn (red.p, red.coef, currRing);
       }
       else
       {
-	if (npIsOne (red.coef))
-	  t = red.p;
-	else
-	  t = p_Mult_nn (red.p, red.coef, currRing);
+        if(npIsOne (red.coef))
+          t = red.p;
+        else
+          t = p_Mult_nn (red.p, red.coef, currRing);
       }
       kBucket_Add_q (bucket, t, &red.len);
@@ -2675,8 +2609,8 @@
 #ifndef NORO_NON_POLY
 std::vector < NoroPlaceHolder > noro_red (poly p, int &len, NoroCache * cache,
-					  slimgb_alg * c)
+                                          slimgb_alg * c)
 {
   std::vector < NoroPlaceHolder > res;
-  while (p)
+  while(p)
   {
     poly t = p;
@@ -2692,5 +2626,5 @@
     h.coef = red.coef;
     assume (!((h.ref->value_poly == NULL) && (h.ref->value_len != 0)));
-    if (h.ref->value_poly)
+    if(h.ref->value_poly)
       res.push_back (h);
   }
@@ -2702,6 +2636,5 @@
 #ifdef USE_NORO
 #ifndef NORO_CACHE
-void
-noro_step (poly * p, int &pn, slimgb_alg * c)
+void noro_step (poly * p, int &pn, slimgb_alg * c)
 {
   poly *reduced = (poly *) omalloc (pn * sizeof (poly));
@@ -2714,5 +2647,5 @@
   NoroCache cache;
 #endif
-  for (j = 0; j < pn; j++)
+  for(j = 0; j < pn; j++)
   {
 
@@ -2727,5 +2660,5 @@
     assume (pLength (h) == h_len);
 #endif
-    if (h != NULL)
+    if(h != NULL)
     {
 #ifndef NORO_CACHE
@@ -2737,10 +2670,10 @@
       reduced_len[reduced_c] = h_len;
       reduced_c++;
-      if (TEST_OPT_PROT)
-	Print ("%d ", h_len);
+      if(TEST_OPT_PROT)
+        Print ("%d ", h_len);
     }
   }
   int reduced_sum = 0;
-  for (j = 0; j < reduced_c; j++)
+  for(j = 0; j < reduced_c; j++)
   {
     reduced_sum += reduced_len[j];
@@ -2748,9 +2681,9 @@
   poly *terms = (poly *) omalloc (reduced_sum * sizeof (poly));
   int tc = 0;
-  for (j = 0; j < reduced_c; j++)
+  for(j = 0; j < reduced_c; j++)
   {
     poly h = reduced[j];
 
-    while (h != NULL)
+    while(h != NULL)
     {
       terms[tc++] = h;
@@ -2774,5 +2707,5 @@
   omfree (reduced);
 
-  if (TEST_OPT_PROT)
+  if(TEST_OPT_PROT)
     PrintS ("\n");
 }
@@ -2781,6 +2714,5 @@
 #endif
 #endif
-static void
-go_on (slimgb_alg * c)
+static void go_on (slimgb_alg * c)
 {
   //set limit of 1000 for multireductions, at the moment for
@@ -2794,5 +2726,5 @@
   int i = 0;
   c->average_length = 0;
-  for (i = 0; i < c->n; i++)
+  for(i = 0; i < c->n; i++)
   {
     c->average_length += c->lengths[i];
@@ -2803,21 +2735,21 @@
 
 #ifdef USE_NORO
-  if ((use_noro) || (c->use_noro_last_block))
+  if((use_noro) || (c->use_noro_last_block))
     max_pairs = bundle_size_noro;
 #endif
-  poly *p = (poly *) omalloc ((max_pairs + 1) * sizeof (poly));	//nullterminated
+  poly *p = (poly *) omalloc ((max_pairs + 1) * sizeof (poly)); //nullterminated
 
   int curr_deg = -1;
-  while (i < max_pairs)
-  {
-    sorted_pair_node *s = top_pair (c);	//here is actually chain criterium done
-
-    if (!s)
+  while(i < max_pairs)
+  {
+    sorted_pair_node *s = top_pair (c); //here is actually chain criterium done
+
+    if(!s)
       break;
 
-    if (curr_deg >= 0)
-    {
-      if (s->deg > curr_deg)
-	break;
+    if(curr_deg >= 0)
+    {
+      if(s->deg > curr_deg)
+        break;
     }
 
@@ -2825,5 +2757,5 @@
       curr_deg = s->deg;
     quick_pop_pair (c);
-    if (s->i >= 0)
+    if(s->i >= 0)
     {
       //be careful replace_pair use createShortSpoly which is not noncommutative
@@ -2831,25 +2763,25 @@
       replace_pair (s->i, s->j, c);
 
-      if (s->i == s->j)
-      {
-	free_sorted_pair_node (s, c->r);
-	continue;
+      if(s->i == s->j)
+      {
+        free_sorted_pair_node (s, c->r);
+        continue;
       }
       now_t_rep (s->i, s->j, c);
     }
     poly h;
-    if (s->i >= 0)
+    if(s->i >= 0)
     {
 #ifdef HAVE_PLURAL
-      if (c->nc)
-      {
-	h = nc_CreateSpoly (c->S->m[s->i], c->S->m[s->j] /*, NULL */ , c->r);
-
-	if (h != NULL)
-	  p_Cleardenom (h, c->r);
+      if(c->nc)
+      {
+        h = nc_CreateSpoly (c->S->m[s->i], c->S->m[s->j] /*, NULL */ , c->r);
+
+        if(h != NULL)
+          p_Cleardenom (h, c->r);
       }
       else
 #endif
-	h = ksOldCreateSpoly (c->S->m[s->i], c->S->m[s->j], NULL, c->r);
+        h = ksOldCreateSpoly (c->S->m[s->i], c->S->m[s->j], NULL, c->r);
       p_Test (h, c->r);
     }
@@ -2864,5 +2796,5 @@
     int mlen = pLength (h);
     p_Test (h, c->r);
-    if ((!c->nc) & (!(use_noro)))
+    if((!c->nc) & (!(use_noro)))
     {
       h = redNF2 (h, c, mlen, coef, 2);
@@ -2872,5 +2804,5 @@
     p_Test (h, c->r);
     free_sorted_pair_node (s, c->r);
-    if (!h)
+    if(!h)
       continue;
     p[i] = h;
@@ -2879,5 +2811,5 @@
   p[i] = NULL;
 //  pre_comp(p,i,c);
-  if (i == 0)
+  if(i == 0)
   {
     omfree (p);
@@ -2894,8 +2826,8 @@
   //if ((!(c->nc))&&(rField_is_Zp(c->r)))
   //{
-  if (use_noro)
+  if(use_noro)
   {
     int pn = i;
-    if (pn == 0)
+    if(pn == 0)
     {
       omfree (p);
@@ -2903,18 +2835,18 @@
     }
     {
-      if (npPrimeM < 255)
-      {
-	noro_step < tgb_uint8 > (p, pn, c);
+      if(npPrimeM < 255)
+      {
+        noro_step < tgb_uint8 > (p, pn, c);
       }
       else
       {
-	if (npPrimeM < 65000)
-	{
-	  noro_step < tgb_uint16 > (p, pn, c);
-	}
-	else
-	{
-	  noro_step < tgb_uint32 > (p, pn, c);
-	}
+        if(npPrimeM < 65000)
+        {
+          noro_step < tgb_uint16 > (p, pn, c);
+        }
+        else
+        {
+          noro_step < tgb_uint32 > (p, pn, c);
+        }
       }
     }
@@ -2935,5 +2867,5 @@
 #endif
   red_object *buf = (red_object *) omalloc (i * sizeof (red_object));
-  for (j = 0; j < i; j++)
+  for(j = 0; j < i; j++)
   {
     p_Test (p[j], c->r);
@@ -2942,5 +2874,5 @@
     buf[j].bucket = kBucketCreate (currRing);
     p_Test (p[j], c->r);
-    if (c->eliminationProblem)
+    if(c->eliminationProblem)
     {
       buf[j].sugar = c->pTotaldegree_full (p[j]);
@@ -2954,5 +2886,5 @@
   qsort (buf, i, sizeof (red_object), red_object_better_gen);
 //    Print("\ncurr_deg:%i\n",curr_deg);
-  if (TEST_OPT_PROT)
+  if(TEST_OPT_PROT)
   {
     Print ("%dM[%d,", curr_deg, i);
@@ -2961,22 +2893,22 @@
   multi_reduction (buf, i, c);
 #ifdef TGB_RESORT_PAIRS
-  if (c->used_b)
-  {
-    if (TEST_OPT_PROT)
+  if(c->used_b)
+  {
+    if(TEST_OPT_PROT)
       PrintS ("B");
     int e;
-    for (e = 0; e <= c->pair_top; e++)
-    {
-      if (c->apairs[e]->i < 0)
-	continue;
+    for(e = 0; e <= c->pair_top; e++)
+    {
+      if(c->apairs[e]->i < 0)
+        continue;
       assume (c->apairs[e]->j >= 0);
-      if ((c->replaced[c->apairs[e]->i]) || (c->replaced[c->apairs[e]->j]))
-      {
-	sorted_pair_node *s = c->apairs[e];
-	s->expected_length = pair_weighted_length (s->i, s->j, c);
+      if((c->replaced[c->apairs[e]->i]) || (c->replaced[c->apairs[e]->j]))
+      {
+        sorted_pair_node *s = c->apairs[e];
+        s->expected_length = pair_weighted_length (s->i, s->j, c);
       }
     }
     qsort (c->apairs, c->pair_top + 1, sizeof (sorted_pair_node *),
-	   tgb_pair_better_gen2);
+           tgb_pair_better_gen2);
   }
 #endif
@@ -2984,15 +2916,15 @@
   {
     int k;
-    for (k = 0; k < i; k++)
+    for(k = 0; k < i; k++)
     {
       assume (kFindDivisibleByInS_easy (c->strat, buf[k]) < 0);
       int k2;
-      for (k2 = 0; k2 < i; k2++)
-      {
-	if (k == k2)
-	  continue;
-	assume ((!(p_LmDivisibleBy (buf[k].p, buf[k2].p, c->r)))
-		|| (wrp (buf[k].p), Print (" k %d k2 %d ", k, k2),
-		    wrp (buf[k2].p), FALSE));
+      for(k2 = 0; k2 < i; k2++)
+      {
+        if(k == k2)
+          continue;
+        assume ((!(p_LmDivisibleBy (buf[k].p, buf[k2].p, c->r)))
+                || (wrp (buf[k].p), Print (" k %d k2 %d ", k, k2),
+                    wrp (buf[k2].p), FALSE));
       }
     }
@@ -3001,9 +2933,9 @@
   //resort S
 
-  if (TEST_OPT_PROT)
+  if(TEST_OPT_PROT)
     Print ("%i]", i);
 
   poly *add_those = (poly *) omalloc (i * sizeof (poly));
-  for (j = 0; j < i; j++)
+  for(j = 0; j < i; j++)
   {
     int len;
@@ -3014,5 +2946,5 @@
     p_Test (p, c->r);
     //if (!c->nc) {
-    if ((c->tailReductions) || (lies_in_last_dp_block (p, c)))
+    if((c->tailReductions) || (lies_in_last_dp_block (p, c)))
     {
       p = redNFTail (p, c->strat->sl, c->strat, 0);
@@ -3032,5 +2964,5 @@
   omfree (buf);
 
-  if (TEST_OPT_PROT)
+  if(TEST_OPT_PROT)
     Print ("(%d)", c->pair_top + 1);
   //TODO: implement that while(!(idIs0(c->add_later)))
@@ -3045,14 +2977,13 @@
 #ifdef REDTAIL_S
 
-static poly
-redNFTail (poly h, const int sl, kStrategy strat, int len)
+static poly redNFTail (poly h, const int sl, kStrategy strat, int len)
 {
   BOOLEAN nc = rIsPluralRing (currRing);
-  if (h == NULL)
+  if(h == NULL)
     return NULL;
   pTest (h);
-  if (0 > sl)
+  if(0 > sl)
     return h;
-  if (pNext (h) == NULL)
+  if(pNext (h) == NULL)
     return h;
 
@@ -3065,5 +2996,5 @@
   len--;
   h = P.p;
-  if (len <= 0)
+  if(len <= 0)
     len = pLength (h);
   kBucketInit (P.bucket, h /*P.p */ , len /*pLength(P.p) */ );
@@ -3077,55 +3008,55 @@
     {
       //int dummy=strat->sl;
-      j = kFindDivisibleByInS_easy (strat, P.p, P.sev);	//kFindDivisibleByInS(strat,&dummy,&P);
-      if (j >= 0)
+      j = kFindDivisibleByInS_easy (strat, P.p, P.sev); //kFindDivisibleByInS(strat,&dummy,&P);
+      if(j >= 0)
       {
 #ifdef REDTAIL_PROT
-	PrintS ("r");
-#endif
-	nNormalize (pGetCoeff (P.p));
+        PrintS ("r");
+#endif
+        nNormalize (pGetCoeff (P.p));
 #ifdef KDEBUG
-	if (TEST_OPT_DEBUG)
-	{
-	  PrintS ("red tail:");
-	  wrp (h);
-	  PrintS (" with ");
-	  wrp (strat->S[j]);
-	}
-#endif
-	number coef;
-	pTest (strat->S[j]);
+        if(TEST_OPT_DEBUG)
+        {
+          PrintS ("red tail:");
+          wrp (h);
+          PrintS (" with ");
+          wrp (strat->S[j]);
+        }
+#endif
+        number coef;
+        pTest (strat->S[j]);
 #ifdef HAVE_PLURAL
-	if (nc)
-	{
-	  nc_BucketPolyRed_Z (P.bucket, strat->S[j], &coef);
-	}
-	else
-#endif
-	  coef = kBucketPolyRed (P.bucket, strat->S[j],
-				 strat->lenS[j] /*pLength(strat->S[j]) */ ,
-				 strat->kNoether);
-	pMult_nn (res, coef);
-	nDelete (&coef);
-	h = kBucketGetLm (P.bucket);
-	pTest (h);
-	if (h == NULL)
-	{
+        if(nc)
+        {
+          nc_BucketPolyRed_Z (P.bucket, strat->S[j], &coef);
+        }
+        else
+#endif
+          coef = kBucketPolyRed (P.bucket, strat->S[j],
+                                 strat->lenS[j] /*pLength(strat->S[j]) */ ,
+                                 strat->kNoether);
+        pMult_nn (res, coef);
+        nDelete (&coef);
+        h = kBucketGetLm (P.bucket);
+        pTest (h);
+        if(h == NULL)
+        {
 #ifdef REDTAIL_PROT
-	  PrintS (" ");
-#endif
-	  kBucketDestroy (&P.bucket);
-	  return res;
-	}
-	pTest (h);
-	P.p = h;
-	P.t_p = NULL;
-	P.SetShortExpVector ();
+          PrintS (" ");
+#endif
+          kBucketDestroy (&P.bucket);
+          return res;
+        }
+        pTest (h);
+        P.p = h;
+        P.t_p = NULL;
+        P.SetShortExpVector ();
 #ifdef KDEBUG
-	if (TEST_OPT_DEBUG)
-	{
-	  PrintS ("\nto tail:");
-	  wrp (h);
-	  PrintLn ();
-	}
+        if(TEST_OPT_DEBUG)
+        {
+          PrintS ("\nto tail:");
+          wrp (h);
+          PrintLn ();
+        }
 #endif
       }
@@ -3133,9 +3064,9 @@
       {
 #ifdef REDTAIL_PROT
-	PrintS ("n");
-#endif
-	break;
-      }
-    }				/* end loop current mon */
+        PrintS ("n");
+#endif
+        break;
+      }
+    }                           /* end loop current mon */
     //   poly tmp=pHead(h /*kBucketGetLm(P.bucket)*/);
     //act->next=tmp;pIter(act);
@@ -3143,5 +3074,5 @@
     pIter (act);
     h = kBucketGetLm (P.bucket);
-    if (h == NULL)
+    if(h == NULL)
     {
 #ifdef REDTAIL_PROT
@@ -3160,6 +3091,5 @@
 
 //transfers ownership of m to mat
-void
-init_with_mac_poly (tgb_sparse_matrix * mat, int row, mac_poly m)
+void init_with_mac_poly (tgb_sparse_matrix * mat, int row, mac_poly m)
 {
   assume (mat->mp[row] == NULL);
@@ -3167,5 +3097,5 @@
 #ifdef TGB_DEBUG
   mac_poly r = m;
-  while (r)
+  while(r)
   {
     assume (r->exp < mat->columns);
@@ -3177,5 +3107,5 @@
 poly
 free_row_to_poly (tgb_sparse_matrix * mat, int row, poly * monoms,
-		  int monom_index)
+                  int monom_index)
 {
   poly p = NULL;
@@ -3183,5 +3113,5 @@
   mac_poly r = mat->mp[row];
   mat->mp[row] = NULL;
-  while (r)
+  while(r)
   {
     (*set_this) = pLmInit (monoms[monom_index - 1 - r->exp]);
@@ -3196,6 +3126,5 @@
 }
 
-static int
-poly_crit (const void *ap1, const void *ap2)
+static int poly_crit (const void *ap1, const void *ap2)
 {
   poly p1, p2;
@@ -3204,24 +3133,23 @@
 
   int c = pLmCmp (p1, p2);
-  if (c != 0)
+  if(c != 0)
     return c;
   int l1 = pLength (p1);
   int l2 = pLength (p2);
-  if (l1 < l2)
+  if(l1 < l2)
     return -1;
-  if (l1 > l2)
+  if(l1 > l2)
     return 1;
   return 0;
 }
 
-void
-slimgb_alg::introduceDelayedPairs (poly * pa, int s)
-{
-  if (s == 0)
+void slimgb_alg::introduceDelayedPairs (poly * pa, int s)
+{
+  if(s == 0)
     return;
   sorted_pair_node **si_array =
     (sorted_pair_node **) omalloc (s * sizeof (sorted_pair_node *));
 
-  for (int i = 0; i < s; i++)
+  for(int i = 0; i < s; i++)
   {
     sorted_pair_node *si =
@@ -3265,20 +3193,20 @@
   {
     int hzz;
-    for (hzz = 0; hzz < IDELEMS (I); hzz++)
+    for(hzz = 0; hzz < IDELEMS (I); hzz++)
     {
       assume (I->m[hzz] != NULL);
       int d = this->pTotaldegree (I->m[hzz]);
       poly t = I->m[hzz]->next;
-      while (t)
-      {
-	if (d != this->pTotaldegree (t))
-	{
-	  is_homog = FALSE;
-	  break;
-	}
-	t = t->next;
-      }
-      if (!(is_homog))
-	break;
+      while(t)
+      {
+        if(d != this->pTotaldegree (t))
+        {
+          is_homog = FALSE;
+          break;
+        }
+        t = t->next;
+      }
+      if(!(is_homog))
+        break;
     }
   }
@@ -3291,5 +3219,5 @@
   easy_product_crit = 0;
   extended_product_crit = 0;
-  if (rField_is_Zp (r))
+  if(rField_is_Zp (r))
     isDifficultField = FALSE;
   else
@@ -3327,5 +3255,5 @@
   this->n = 0;
   T_deg = (int *) omalloc (n * sizeof (int));
-  if (eliminationProblem)
+  if(eliminationProblem)
     T_deg_full = (int *) omalloc (n * sizeof (int));
   else
@@ -3352,10 +3280,10 @@
 
   short_Exps = (long *) omalloc (n * sizeof (long));
-  if (F4_mode)
+  if(F4_mode)
     S = idInit (n, I->rank);
   else
     S = idInit (1, I->rank);
   strat = new skStrategy;
-  if (eliminationProblem)
+  if(eliminationProblem)
     strat->honey = TRUE;
   strat->syzComp = 0;
@@ -3367,17 +3295,17 @@
   strat->sl = -1;
   i = n;
-  i = 1;			//some strange bug else
+  i = 1;                        //some strange bug else
   /* initS(c->S,NULL,c->strat); */
   /* intS start: */
   // i=((i+IDELEMS(c->S)+15)/16)*16;
-  strat->ecartS = (intset) omAlloc (i * sizeof (int));	/*initec(i); */
+  strat->ecartS = (intset) omAlloc (i * sizeof (int));  /*initec(i); */
   strat->sevS = (unsigned long *) omAlloc0 (i * sizeof (unsigned long));
   /*initsevS(i); */
-  strat->S_2_R = (int *) omAlloc0 (i * sizeof (int));	/*initS_2_R(i); */
+  strat->S_2_R = (int *) omAlloc0 (i * sizeof (int));   /*initS_2_R(i); */
   strat->fromQ = NULL;
   strat->Shdl = idInit (1, 1);
   strat->S = strat->Shdl->m;
   strat->lenS = (int *) omAlloc0 (i * sizeof (int));
-  if ((isDifficultField) || (eliminationProblem))
+  if((isDifficultField) || (eliminationProblem))
     strat->lenSw = (wlen_type *) omAlloc0 (i * sizeof (wlen_type));
   else
@@ -3387,5 +3315,5 @@
 
   assume (strat->sl == IDELEMS (strat->Shdl) - 1);
-  if (!(F4_mode))
+  if(!(F4_mode))
   {
     poly *array_arg = I->m;
@@ -3414,8 +3342,8 @@
   else
   {
-    for (i = 1; i < n; i++)	//the 1 is wanted, because first element is added to basis
+    for(i = 1; i < n; i++)      //the 1 is wanted, because first element is added to basis
       add_to_basis_ideal_quotient (I->m[i], this, NULL);
   }
-  for (i = 0; i < IDELEMS (I); i++)
+  for(i = 0; i < IDELEMS (I); i++)
   {
     I->m[i] = NULL;
@@ -3425,10 +3353,10 @@
 #ifdef USE_NORO
   use_noro = ((!(nc)) && (S->rank <= 1) && (rField_is_Zp (r))
-	      && (!(eliminationProblem)) && (npPrimeM <= 32003));
+              && (!(eliminationProblem)) && (npPrimeM <= 32003));
   use_noro_last_block = false;
-  if ((!(use_noro)) && (lastDpBlockStart <= pVariables))
+  if((!(use_noro)) && (lastDpBlockStart <= pVariables))
   {
     use_noro_last_block = ((!(nc)) && (S->rank <= 1) && (rField_is_Zp (r))
-			   && (npPrimeM <= 32003));
+                           && (npPrimeM <= 32003));
   }
 #else
@@ -3443,20 +3371,20 @@
 {
 
-  if (!(completed))
+  if(!(completed))
   {
     poly *add = (poly *) omalloc ((pair_top + 2) * sizeof (poly));
     int piter;
     int pos = 0;
-    for (piter = 0; piter <= pair_top; piter++)
+    for(piter = 0; piter <= pair_top; piter++)
     {
       sorted_pair_node *s = apairs[piter];
-      if (s->i < 0)
-      {
-	//delayed element
-	if (s->lcm_of_lm != NULL)
-	{
-	  add[pos] = s->lcm_of_lm;
-	  pos++;
-	}
+      if(s->i < 0)
+      {
+        //delayed element
+        if(s->lcm_of_lm != NULL)
+        {
+          add[pos] = s->lcm_of_lm;
+          pos++;
+        }
       }
       free_sorted_pair_node (s, r);
@@ -3466,10 +3394,10 @@
     add[pos] = NULL;
     pos = 0;
-    while (add[pos] != NULL)
+    while(add[pos] != NULL)
     {
       add_to_basis_ideal_quotient (add[pos], this, NULL);
       pos++;
     }
-    for (piter = 0; piter <= pair_top; piter++)
+    for(piter = 0; piter <= pair_top; piter++)
     {
       sorted_pair_node *s = apairs[piter];
@@ -3483,5 +3411,5 @@
   int i, j;
   slimgb_alg *c = this;
-  while (c->to_destroy)
+  while(c->to_destroy)
   {
     pDelete (&(c->to_destroy->p));
@@ -3490,7 +3418,7 @@
     omfree (old);
   }
-  while (c->F)
-  {
-    for (i = 0; i < c->F->size; i++)
+  while(c->F)
+  {
+    for(i = 0; i < c->F->size; i++)
     {
       pDelete (&(c->F->mp[i].m));
@@ -3502,7 +3430,7 @@
     omfree (old);
   }
-  while (c->F_minus)
-  {
-    for (i = 0; i < c->F_minus->size; i++)
+  while(c->F_minus)
+  {
+    for(i = 0; i < c->F_minus->size; i++)
     {
       pDelete (&(c->F_minus->p[i]));
@@ -3516,5 +3444,5 @@
 #ifndef HAVE_BOOST
 #ifndef USE_STDVECBOOL
-  for (int z = 1 /* zero length at 0 */ ; z < c->n; z++)
+  for(int z = 1 /* zero length at 0 */ ; z < c->n; z++)
   {
     omfree (c->states[z]);
@@ -3526,5 +3454,5 @@
   omfree (c->lengths);
   omfree (c->weighted_lengths);
-  for (int z = 0; z < c->n; z++)
+  for(int z = 0; z < c->n; z++)
   {
     pDelete (&c->tmp_pair_lm[z]);
@@ -3535,5 +3463,5 @@
 
   omfree (c->T_deg);
-  if (c->T_deg_full)
+  if(c->T_deg_full)
     omfree (c->T_deg_full);
 
@@ -3546,10 +3474,10 @@
   omFree (c->strat->lenS);
 
-  if (c->strat->lenSw)
+  if(c->strat->lenSw)
     omFree (c->strat->lenSw);
 
-  for (i = 0; i < c->n; i++)
-  {
-    if (c->gcd_of_terms[i])
+  for(i = 0; i < c->n; i++)
+  {
+    if(c->gcd_of_terms[i])
       pDelete (&(c->gcd_of_terms[i]));
   }
@@ -3557,25 +3485,25 @@
 
   omfree (c->apairs);
-  if (TEST_OPT_PROT)
+  if(TEST_OPT_PROT)
   {
     //Print("calculated %d NFs\n",c->normal_forms);
     Print ("\nNF:%i product criterion:%i, ext_product criterion:%i \n",
-	   c->normal_forms, c->easy_product_crit, c->extended_product_crit);
-  }
-
-  for (i = 0; i <= c->strat->sl; i++)
-  {
-    if (!c->strat->S[i])
+           c->normal_forms, c->easy_product_crit, c->extended_product_crit);
+  }
+
+  for(i = 0; i <= c->strat->sl; i++)
+  {
+    if(!c->strat->S[i])
       continue;
     BOOLEAN found = FALSE;
-    for (j = 0; j < c->n; j++)
-    {
-      if (c->S->m[j] == c->strat->S[i])
-      {
-	found = TRUE;
-	break;
-      }
-    }
-    if (!found)
+    for(j = 0; j < c->n; j++)
+    {
+      if(c->S->m[j] == c->strat->S[i])
+      {
+        found = TRUE;
+        break;
+      }
+    }
+    if(!found)
       pDelete (&c->strat->S[i]);
   }
@@ -3597,26 +3525,26 @@
 //   }
 
-  if (completed)
-  {
-    for (i = 0; i < c->n; i++)
+  if(completed)
+  {
+    for(i = 0; i < c->n; i++)
     {
       assume (c->S->m[i] != NULL);
-      if (p_GetComp (c->S->m[i], currRing) > this->syz_comp)
-	continue;
-      for (j = 0; j < c->n; j++)
-      {
-	if ((c->S->m[j] == NULL) || (i == j))
-	  continue;
-	assume (p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
-				      c->S->m[i], ~c->short_Exps[i],
-				      c->r) == p_LmDivisibleBy (c->S->m[j],
-								c->S->m[i],
-								c->r));
-	if (p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
-				  c->S->m[i], ~c->short_Exps[i], c->r))
-	{
-	  pDelete (&c->S->m[i]);
-	  break;
-	}
+      if(p_GetComp (c->S->m[i], currRing) > this->syz_comp)
+        continue;
+      for(j = 0; j < c->n; j++)
+      {
+        if((c->S->m[j] == NULL) || (i == j))
+          continue;
+        assume (p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
+                                      c->S->m[i], ~c->short_Exps[i],
+                                      c->r) == p_LmDivisibleBy (c->S->m[j],
+                                                                c->S->m[i],
+                                                                c->r));
+        if(p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
+                                 c->S->m[i], ~c->short_Exps[i], c->r))
+        {
+          pDelete (&c->S->m[i]);
+          break;
+        }
       }
     }
@@ -3627,5 +3555,5 @@
   IDELEMS (I) = c->n;
   idSkipZeroes (I);
-  for (i = 0; i <= c->strat->sl; i++)
+  for(i = 0; i <= c->strat->sl; i++)
     c->strat->S[i] = NULL;
   id_Delete (&c->strat->Shdl, c->r);
@@ -3635,6 +3563,5 @@
 }
 
-ideal
-t_rep_gb (ring r, ideal arg_I, int syz_comp, BOOLEAN F4_mode)
+ideal t_rep_gb (ring r, ideal arg_I, int syz_comp, BOOLEAN F4_mode)
 {
   assume (r == currRing);
@@ -3643,5 +3570,5 @@
   ring new_ring = rAssure_TDeg (orig_ring, 1, rVar (orig_ring), pos);
   ideal s_h;
-  if (orig_ring != new_ring)
+  if(orig_ring != new_ring)
   {
     rChangeCurrRing (new_ring);
@@ -3666,5 +3593,5 @@
   ideal s_result = do_t_rep_gb (new_ring, s_h, syz_comp, F4_mode, pos);
   ideal result;
-  if (orig_ring != new_ring)
+  if(orig_ring != new_ring)
   {
     idTest (s_result);
@@ -3688,6 +3615,6 @@
   //  Print("QlogSize(0) %d, QlogSize(1) %d,QlogSize(-2) %d, QlogSize(5) %d\n", QlogSize(nlInit(0)),QlogSize(nlInit(1)),QlogSize(nlInit(-2)),QlogSize(nlInit(5)));
 
-  if (TEST_OPT_PROT)
-    if (F4_mode)
+  if(TEST_OPT_PROT)
+    if(F4_mode)
       PrintS ("F4 Modus \n");
 
@@ -3697,8 +3624,8 @@
   ideal I = arg_I;
   idCompactify (I);
-  if (idIs0 (I))
+  if(idIs0 (I))
     return I;
   int i;
-  for (i = 0; i < IDELEMS (I); i++)
+  for(i = 0; i < IDELEMS (I); i++)
   {
     assume (I->m[i] != NULL);
@@ -3712,10 +3639,10 @@
   slimgb_alg *c = new slimgb_alg (I, syz_comp, F4_mode, deg_pos);
 
-  while ((c->pair_top >= 0)
-	 && ((!(TEST_OPT_DEGBOUND))
-	     || (c->apairs[c->pair_top]->deg <= Kstd1_deg)))
+  while((c->pair_top >= 0)
+        && ((!(TEST_OPT_DEGBOUND))
+            || (c->apairs[c->pair_top]->deg <= Kstd1_deg)))
   {
 #ifdef HAVE_F4
-    if (F4_mode)
+    if(F4_mode)
       go_on_F4 (c);
     else
@@ -3723,9 +3650,9 @@
       go_on (c);
   }
-  if (c->pair_top < 0)
+  if(c->pair_top < 0)
     c->completed = TRUE;
   I = c->S;
   delete c;
-  if (TEST_OPT_REDSB)
+  if(TEST_OPT_REDSB)
   {
     ideal erg = kInterRed (I, NULL);
@@ -3739,13 +3666,12 @@
 }
 
-void
-now_t_rep (const int &arg_i, const int &arg_j, slimgb_alg * c)
+void now_t_rep (const int &arg_i, const int &arg_j, slimgb_alg * c)
 {
   int i, j;
-  if (arg_i == arg_j)
+  if(arg_i == arg_j)
   {
     return;
   }
-  if (arg_i > arg_j)
+  if(arg_i > arg_j)
   {
     i = arg_j;
@@ -3767,9 +3693,9 @@
   assume (arg_i < state->n);
   assume (arg_j < state->n);
-  if (arg_i == arg_j)
+  if(arg_i == arg_j)
   {
     return (TRUE);
   }
-  if (arg_i > arg_j)
+  if(arg_i > arg_j)
   {
     return (state->states[arg_i][arg_j] == HASTREP);
@@ -3781,11 +3707,10 @@
 }
 
-#if 0				// unused
-static int
-pLcmDeg (poly a, poly b)
+#if 0                           // unused
+static int pLcmDeg (poly a, poly b)
 {
   int i;
   int n = 0;
-  for (i = pVariables; i; i--)
+  for(i = pVariables; i; i--)
   {
     n += si_max (pGetExp (a, i), pGetExp (b, i));
@@ -3795,34 +3720,33 @@
 #endif
 
-static void
-shorten_tails (slimgb_alg * c, poly monom)
+static void shorten_tails (slimgb_alg * c, poly monom)
 {
   return;
 // BOOLEAN corr=lenS_correct(c->strat);
-  for (int i = 0; i < c->n; i++)
+  for(int i = 0; i < c->n; i++)
   {
     //enter tail
 
-    if (c->S->m[i] == NULL)
+    if(c->S->m[i] == NULL)
       continue;
     poly tail = c->S->m[i]->next;
     poly prev = c->S->m[i];
     BOOLEAN did_something = FALSE;
-    while ((tail != NULL) && (pLmCmp (tail, monom) >= 0))
-    {
-      if (p_LmDivisibleBy (monom, tail, c->r))
-      {
-	did_something = TRUE;
-	prev->next = tail->next;
-	tail->next = NULL;
-	p_Delete (&tail, c->r);
-	tail = prev;
-	//PrintS("Shortened");
-	c->lengths[i]--;
+    while((tail != NULL) && (pLmCmp (tail, monom) >= 0))
+    {
+      if(p_LmDivisibleBy (monom, tail, c->r))
+      {
+        did_something = TRUE;
+        prev->next = tail->next;
+        tail->next = NULL;
+        p_Delete (&tail, c->r);
+        tail = prev;
+        //PrintS("Shortened");
+        c->lengths[i]--;
       }
       prev = tail;
       tail = tail->next;
     }
-    if (did_something)
+    if(did_something)
     {
       int new_pos;
@@ -3833,29 +3757,29 @@
       int old_pos = -1;
       //assume new_pos<old_pos
-      for (int z = 0; z <= c->strat->sl; z++)
-      {
-	if (c->strat->S[z] == c->S->m[i])
-	{
-	  old_pos = z;
-	  break;
-	}
-      }
-      if (old_pos == -1)
-	for (int z = new_pos - 1; z >= 0; z--)
-	{
-	  if (c->strat->S[z] == c->S->m[i])
-	  {
-	    old_pos = z;
-	    break;
-	  }
-	}
+      for(int z = 0; z <= c->strat->sl; z++)
+      {
+        if(c->strat->S[z] == c->S->m[i])
+        {
+          old_pos = z;
+          break;
+        }
+      }
+      if(old_pos == -1)
+        for(int z = new_pos - 1; z >= 0; z--)
+        {
+          if(c->strat->S[z] == c->S->m[i])
+          {
+            old_pos = z;
+            break;
+          }
+        }
       assume (old_pos >= 0);
       assume (new_pos <= old_pos);
       assume (pLength (c->strat->S[old_pos]) == c->lengths[i]);
       c->strat->lenS[old_pos] = c->lengths[i];
-      if (c->strat->lenSw)
-	c->strat->lenSw[old_pos] = q;
-      if (new_pos < old_pos)
-	move_forward_in_S (old_pos, new_pos, c->strat);
+      if(c->strat->lenSw)
+        c->strat->lenSw[old_pos] = q;
+      if(new_pos < old_pos)
+        move_forward_in_S (old_pos, new_pos, c->strat);
       length_one_crit (c, i, c->lengths[i]);
     }
